diff -Naur nagios-3.0.3/cgi/extinfo.c nagios-3.0.3-patched/cgi/extinfo.c
--- nagios-3.0.3/cgi/extinfo.c	2008-01-24 03:51:30.000000000 +0100
+++ nagios-3.0.3-patched/cgi/extinfo.c	2008-09-24 13:19:23.000000000 +0200
@@ -136,6 +136,7 @@
 	char temp_buffer[MAX_INPUT_BUFFER]="";
 	char *processed_string=NULL;
 	host *temp_host=NULL;
+	hostsmember *temp_hostsmember=NULL;
 	hostgroup *temp_hostgroup=NULL;
 	service *temp_service=NULL;
 	servicegroup *temp_servicegroup=NULL;
@@ -338,8 +339,24 @@
 				if(found==FALSE)
 					printf("No hostgroups");
 				printf("</DIV><BR>\n");
-				printf("<DIV CLASS='data'>%s</DIV>\n",temp_host->address);
-			        }
+				printf("<DIV CLASS='data'>%s</DIV>\n<BR />\n",temp_host->address);
+ 			        }
+
+				found=FALSE;
+				printf("<DIV CLASS='data'>Parent Host(s):</DIV>\n<DIV CLASS='dataTitle'>\n");
+				if(temp_host->parent_hosts==NULL)
+					printf("<DIV CLASS='dataTitle'>None (This is a root host)</DIV>\n");
+				else {
+					printf("<DIV CLASS='dataTitle'>\n");
+					for(temp_hostsmember=temp_host->parent_hosts;temp_hostsmember!=NULL;temp_hostsmember=temp_hostsmember->next){
+						if(found==TRUE)
+							printf(", ");
+							printf("<A HREF='%s?type=%d&host=%s'>%s</a>\n",EXTINFO_CGI,DISPLAY_HOST_INFO,url_encode(temp_hostsmember->host_name),temp_hostsmember->host_name);
+							found=TRUE;
+					}
+	        		}
+				printf("</DIV>\n<BR />\n");
+
 			if(display_type==DISPLAY_SERVICE_INFO){
 				printf("<DIV CLASS='data'>Service</DIV><DIV CLASS='dataTitle'>%s</DIV><DIV CLASS='data'>On Host</DIV>\n",service_desc);
 				printf("<DIV CLASS='dataTitle'>%s</DIV>\n",temp_host->alias);
@@ -1003,6 +1020,7 @@
 void show_host_info(void){
 	hoststatus *temp_hoststatus;
 	host *temp_host;
+	customvariablesmember *temp_customvariablesmember=NULL;
 	char date_time[MAX_DATETIME_LENGTH];
 	char state_duration[48];
 	char status_age[48];
@@ -1166,8 +1184,20 @@
 		status_age[sizeof(status_age)-1]='\x0';
 
 		get_time_string(&temp_hoststatus->last_update,date_time,(int)sizeof(date_time),SHORT_DATE_TIME);
-		printf("<TR><TD CLASS='dataVar'>Last Update:</td><td CLASS='dataVal'>%s&nbsp;&nbsp;(%s ago)</td></tr>\n",(temp_hoststatus->last_update==(time_t)0)?"N/A":date_time,status_age);
+		printf("<TR><TD CLASS='dataVar'>Last Update:</TD><TD CLASS='dataVal'>%s&nbsp;&nbsp;(%s ago)</TD></TR>\n",(temp_hoststatus->last_update==(time_t)0)?"N/A":date_time,status_age);
 
+		printf("<TR><TD CLASS='dataVar'>Custom Variables:</TD><TD CLASS='dataVal'><TABLE>");
+				if(temp_host->custom_variables==NULL)
+					printf("<TR><TD CLASS='dataVar'>N/A</TD><TD>&nbsp;</TD>\n");
+				else {
+					temp_customvariablesmember=temp_host->custom_variables;
+					for(;temp_customvariablesmember!=NULL;temp_customvariablesmember=temp_customvariablesmember->next){
+                                          printf("<TR><TD CLASS='dataVar'>%s</TD><TD CLASS='dataVal'>%s</TD></TR>\n",temp_customvariablesmember->variable_name, temp_customvariablesmember->variable_value);
+					}
+	        		}
+		printf("</TABLE>\n");
+
+		printf("</TD></TR>\n");
 		printf("</TABLE>\n");
 		printf("</TD></TR>\n");
 		printf("</TABLE>\n");
